//+------------------------------------------------------------------+
//|                                         MTF_Stochastic_3X_V1.mq4 |
//|                                      Copyright  2006, Keris2112 |
//|                                      rewritten PBX               |
//+------------------------------------------------------------------+

#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Aqua
#property indicator_color2 Blue
#property indicator_color3 Magenta
#property indicator_color4 Aqua
#property indicator_color5 Red
#property indicator_color6 Lime
#property indicator_color7 Yellow
#property indicator_maximum 100
#property indicator_minimum 0


//----------------------------------------------------------
//   Stochastic     ( ) 
//       ,     
// 2     Buy-Sell (),      (-)
//         
//----------------------------------------------------------

//         
extern bool Plot_TimeFrame1=false;//TimeFrame1, TimeFrame2, TimeFrame3 -  TF   TF 
extern bool Plot_TimeFrame2=false;
extern bool Plot_TimeFrame3=true;
extern bool ChartSetArrow=true;//    
//  (   )        
//  SignalLineNumber1    
//  SignalLineNumber2     "" () 
extern int SignalLineNumber1=3;//  TF (1-3),      Buy-Sell ()
extern int SignalLineNumber2=1;//  TF (1-3),      Buy-Sell ()
extern int Kperiod=25;// 
extern int Slowing=7;// 
extern int Method=0;// 
extern int Price_field=0;// 
extern int FinalSlowing=2;//       
extern string SoundFile1="Alert.wav";
extern string SoundFile2="Alert.wav";
extern bool UseSound=true;
//---
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
int TimeFrame1;
int TimeFrame2;
int TimeFrame3;
int Dperiod=3;// 
bool SoundBuy = False;
bool SoundSell = False;

//+------------------------------------------------------------------+
//| Void SetArrow  : SetArrow(Time[i],Low[i]-15*Point,241,Blue);|
//+------------------------------------------------------------------+
void SetArrow(datetime ArrowTime, double Price, double ArrowCode, color ArrowColor)
{
 int err;
 string ArrowName = DoubleToStr(ArrowTime,0);
   if (ObjectFind(ArrowName) != -1) ObjectDelete(ArrowName);
   if(!ObjectCreate(ArrowName, OBJ_ARROW, 0, ArrowTime, Price))
    {
      err=GetLastError();
      Print("error: can't create Arrow! code #",err);
      return;
    }
   else
   {
     ObjectSet(ArrowName, OBJPROP_ARROWCODE, ArrowCode);
     ObjectSet(ArrowName, OBJPROP_COLOR , ArrowColor);
     ObjectsRedraw();
   }
}   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
   

//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);
   
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE);
   
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(3,241); 
   SetIndexEmptyValue( 3,0);
   
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(4,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(4,242); 
   SetIndexEmptyValue( 4,0); 
   
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(5,DRAW_ARROW,EMPTY,0);
   SetIndexArrow(5,225); 
   SetIndexEmptyValue( 5,0); 
   
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(6,DRAW_ARROW,EMPTY,0);
   SetIndexArrow(6,226); 
   SetIndexEmptyValue( 6,0); 
   
//  3-    
   switch(Period())
   {
      //case 1 : string TimeFrameStr="Period_M1"; break;
      case 1 : string TimeFrameStr="Period_M5+M15+M30: ";TimeFrame1=5;TimeFrame2=15;TimeFrame3=30;break;
      case 5 : TimeFrameStr="Period_M15+M30+M60: "; TimeFrame1=15; TimeFrame2=30; TimeFrame3=60; break;
      case 15 : TimeFrameStr="Period_M30+M60+H4: "; TimeFrame1=30; TimeFrame2=60; TimeFrame3=240; break;
      case 30 : TimeFrameStr="Period_M60+H4+D1: "; TimeFrame1=60; TimeFrame2=240; TimeFrame3=1440;  break;
      case 60 : TimeFrameStr="Period_H4+D1+W1: "; TimeFrame1=240; TimeFrame2=1440; TimeFrame3=10080;  break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   
   short_name="MTF_Stochastic_3X_V1("+TimeFrameStr+"," + Kperiod + "," + Slowing + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, "TimeFrame1");
   SetIndexLabel(1, "TimeFrame2");
   SetIndexLabel(2, "TimeFrame3");
   
  }
//----Period
   return(0);
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                         |
//+------------------------------------------------------------------+ 
int deinit()
{
	
  int    obj_total=ObjectsTotal();
  string name;
  for(int i=obj_total+1;i>-1;i--){name=ObjectName(i);ObjectDelete(name);} 
}  
//+------------------------------------------------------------------+
//| MTF                                                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray1[];
   datetime TimeArray2[];
   datetime TimeArray3[];
   int    i,limit,y=0,Dir1,Dir1prev,Dir2,Dir2prev,counted_bars=IndicatorCounted();
 
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray1,MODE_TIME,Symbol(),TimeFrame1); 
   ArrayCopySeries(TimeArray2,MODE_TIME,Symbol(),TimeFrame2); 
   ArrayCopySeries(TimeArray3,MODE_TIME,Symbol(),TimeFrame3); 
   
   limit=Bars-counted_bars+TimeFrame3/Period();// 
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray1[y]) y++;
   if(Plot_TimeFrame1) ExtMapBuffer1[i]=
   NormalizeDouble(iStochastic(NULL,TimeFrame1,Kperiod,Dperiod,Slowing,Method,Price_field,MODE_MAIN,y),Digits); 
   else ExtMapBuffer1[i]=EMPTY_VALUE;
   }  
//---  
   for(i=limit;i>=0;i--){
   //ExtMapBuffer1[i]=(ExtMapBuffer1[i]+ExtMapBuffer1[i+1]+ExtMapBuffer1[i+2])/3; 
      for (int cnt=1;cnt<FinalSlowing;cnt++) ExtMapBuffer1[i]=ExtMapBuffer1[i]+ExtMapBuffer1[i+cnt];
      ExtMapBuffer1[i]=ExtMapBuffer1[i]/FinalSlowing;
   }
//---
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray2[y]) y++;
   if(Plot_TimeFrame2) ExtMapBuffer2[i]=
   NormalizeDouble(iStochastic(NULL,TimeFrame2,Kperiod,Dperiod,Slowing,Method,Price_field,MODE_MAIN,y),Digits); 
   else ExtMapBuffer2[i]=EMPTY_VALUE;
   }
//---
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray3[y]) y++;
   if(Plot_TimeFrame3) ExtMapBuffer3[i]=
   NormalizeDouble(iStochastic(NULL,TimeFrame3,Kperiod,Dperiod,Slowing,Method,Price_field,MODE_MAIN,y),Digits); 
   else ExtMapBuffer3[i]=EMPTY_VALUE;
   }
//     

   if(SignalLineNumber1<1) SignalLineNumber1=1;//    
   if(SignalLineNumber1>3) SignalLineNumber1=3;
   if(SignalLineNumber2<1) SignalLineNumber2=1;
   if(SignalLineNumber2>3) SignalLineNumber2=3;
//---   SignalLineNumber1
//---      ,
//---      
//---      (   )    
   for(i=limit;i>=0;i--)
   {
      
      switch(SignalLineNumber1)
      {
      case 1 : if(ExtMapBuffer1[i]>ExtMapBuffer1[i+1]) Dir1= 1;
               if(ExtMapBuffer1[i]<ExtMapBuffer1[i+1]) Dir1=-1;
               if(ExtMapBuffer1[i+1]>ExtMapBuffer1[i+2]) Dir1prev= 1;
               if(ExtMapBuffer1[i+1]<ExtMapBuffer1[i+2]) Dir1prev=-1;
               if(Dir1== 1 && Dir1prev==-1){ExtMapBuffer4[i]=ExtMapBuffer1[i];if(ChartSetArrow)SetArrow(Time[i],Low[i],241,Blue);}
               if(Dir1==-1 && Dir1prev== 1){ExtMapBuffer5[i]=ExtMapBuffer1[i];if(ChartSetArrow)SetArrow(Time[i],High[i]+3*Point,242,Red);}
               break;
      case 2 : if(ExtMapBuffer2[i]>ExtMapBuffer2[i+1]) Dir1= 1;
               if(ExtMapBuffer2[i]<ExtMapBuffer2[i+1]) Dir1=-1;
               if(ExtMapBuffer2[i+1]>ExtMapBuffer2[i+2]) Dir1prev= 1;
               if(ExtMapBuffer2[i+1]<ExtMapBuffer2[i+2]) Dir1prev=-1;
               if(Dir1== 1 && Dir1prev==-1){ExtMapBuffer4[i]=ExtMapBuffer2[i];if(ChartSetArrow)SetArrow(Time[i],Low[i],241,Blue);}
               if(Dir1==-1 && Dir1prev== 1){ExtMapBuffer5[i]=ExtMapBuffer2[i];if(ChartSetArrow)SetArrow(Time[i],High[i]+3*Point,242,Red);}
               break;
      case 3 : if(ExtMapBuffer3[i]>ExtMapBuffer3[i+1]) Dir1= 1;
               if(ExtMapBuffer3[i]<ExtMapBuffer3[i+1]) Dir1=-1;
               if(ExtMapBuffer3[i+1]>ExtMapBuffer3[i+2]) Dir1prev= 1;
               if(ExtMapBuffer3[i+1]<ExtMapBuffer3[i+2]) Dir1prev=-1;
               if(Dir1== 1 && Dir1prev==-1){ExtMapBuffer4[i]=ExtMapBuffer3[i];if(ChartSetArrow)SetArrow(Time[i],Low[i],241,Blue);}
               if(Dir1==-1 && Dir1prev== 1){ExtMapBuffer5[i]=ExtMapBuffer3[i];if(ChartSetArrow)SetArrow(Time[i],High[i]+3*Point,242,Red);}
                
               break;         
      }
      
//---   SignalLineNumber2
//---      ,
//---          
//---      (   )
      switch(SignalLineNumber2)
      {
      case 1 : if(ExtMapBuffer1[i]>ExtMapBuffer1[i+1]) Dir2= 1;
               if(ExtMapBuffer1[i]<ExtMapBuffer1[i+1]) Dir2=-1;
               if(ExtMapBuffer1[i+1]>ExtMapBuffer1[i+2]) Dir2prev= 1;
               if(ExtMapBuffer1[i+1]<ExtMapBuffer1[i+2]) Dir2prev=-1;
               if(Dir2== 1 && Dir2prev==-1){ExtMapBuffer6[i]=ExtMapBuffer1[i];if(ChartSetArrow)SetArrow(Time[i],Low[i],251,Blue);} 
               if(Dir2==-1 && Dir2prev== 1){ExtMapBuffer7[i]=ExtMapBuffer1[i];if(ChartSetArrow)SetArrow(Time[i],High[i]+3*Point,251,Red);} 
               break;
      case 2 : if(ExtMapBuffer2[i]>ExtMapBuffer2[i+1]) Dir2= 1;
               if(ExtMapBuffer2[i]<ExtMapBuffer2[i+1]) Dir2=-1;
               if(ExtMapBuffer2[i+1]>ExtMapBuffer2[i+2]) Dir2prev= 1;
               if(ExtMapBuffer2[i+1]<ExtMapBuffer2[i+2]) Dir2prev=-1;
               if(Dir2== 1 && Dir2prev==-1){ExtMapBuffer6[i]=ExtMapBuffer2[i];if(ChartSetArrow)SetArrow(Time[i],Low[i],251,Blue);} 
               if(Dir2==-1 && Dir2prev== 1){ExtMapBuffer7[i]=ExtMapBuffer2[i];if(ChartSetArrow)SetArrow(Time[i],High[i]+3*Point,251,Red);} 
               break;
      case 3 : if(ExtMapBuffer3[i]>ExtMapBuffer3[i+1]) Dir2= 1;
               if(ExtMapBuffer3[i]<ExtMapBuffer3[i+1]) Dir2=-1;
               if(ExtMapBuffer3[i+1]>ExtMapBuffer3[i+2]) Dir2prev= 1;
               if(ExtMapBuffer3[i+1]<ExtMapBuffer3[i+2]) Dir2prev=-1;
               if(Dir2== 1 && Dir2prev==-1){ExtMapBuffer6[i]=ExtMapBuffer3[i];if(ChartSetArrow)SetArrow(Time[i],Low[i],251,Blue);} 
               if(Dir2==-1 && Dir2prev== 1){ExtMapBuffer7[i]=ExtMapBuffer3[i];if(ChartSetArrow)SetArrow(Time[i],High[i]+3*Point,251,Red);} 
               break;         
      }
      
      

   }//                   

//---  1         SignalLineNumber1
      if (ExtMapBuffer4[0] != EMPTY_VALUE && ExtMapBuffer4[0] != 0 && SoundBuy)
         {
         SoundBuy = False;
            if (UseSound) PlaySound (SoundFile1);
         } 
      if (!SoundBuy && (ExtMapBuffer4[0] == EMPTY_VALUE || ExtMapBuffer4[0] == 0)) SoundBuy = True;  
  
      if (ExtMapBuffer5[0] != EMPTY_VALUE && ExtMapBuffer5[0] != 0 && SoundSell)
         {
         SoundSell = False;
            if (UseSound) PlaySound (SoundFile1);
         } 
      if (!SoundSell && (ExtMapBuffer5[0] == EMPTY_VALUE || ExtMapBuffer5[0] == 0)) SoundSell = True;
//---
//---  2 !!!  .

//---   
  
  
   return(0);
  }
//+------------------------------------------------------------------+